<template>
  <div>
    <h2>{{ i3 }}</h2>
    <h3>{{data}}</h3>
    <h3>{{ chartData.datasets[0].data}}</h3>

    <input value="加一" type="button" @click="plusOne" />
    <LineChartGenerator
      :chart-options="chartOptions"
      :chart-data="chartData"
      :chart-id="chartId"
      :dataset-id-key="datasetIdKey"
      :plugins="plugins"
      :css-classes="cssClasses"
      :styles="styles"
      :width="width"
      :height="height"
    />
  </div>
</template>

<script>
import { Line as LineChartGenerator } from "vue-chartjs/legacy";
import Vue, { ref, reactive, defineComponent, computed } from "vue";

import {
  Chart as ChartJS,
  Title,
  Tooltip,
  Legend,
  LineElement,
  LinearScale,
  CategoryScale,
  PointElement,
} from "chart.js";

ChartJS.register(
  Title,
  Tooltip,
  Legend,
  LineElement,
  LinearScale,
  CategoryScale,
  PointElement
);

export default defineComponent({
  name: "LineChart",
  components: {
    LineChartGenerator,
  },
  props: {
    chartId: {
      type: String,
      default: "line-chart",
    },
    datasetIdKey: {
      type: String,
      default: "label",
    },
    width: {
      type: Number,
      default: 400,
    },
    height: {
      type: Number,
      default: 400,
    },
    cssClasses: {
      default: "",
      type: String,
    },
    styles: {
      type: Object,
      default: () => {},
    },
    plugins: {
      type: Array,
      default: () => [],
    },
  },
  setup() {
    const i0 = ref(40);
    const i1 = ref(39);
    const i2 = ref(20);
    const i3 = ref(40);
    const i4 = ref(80);
    const i5 = ref(40);
    const i6 = ref(40);

    let data = computed(()=>[
      i0.value,
      i1.value,
      i2.value,
      i3.value,
      i4.value,
      i5.value,
      i6.value,
    ]);

    const chartData = reactive({
      labels: ["January", "February", "March", "April", "May", "June", "July"],
      datasets: [
        {
          label: "Data One",
          backgroundColor: "#f87979",
          data: data,
        },
      ],
    });
    const chartOptions = ref({
      responsive: true,
      maintainAspectRatio: false,
    });
    const plusOne = () => {
      i3.value = i3.value + 1;
      console.log(datasets.data);
      //  let dataset2 = [{
      //       label: 'Data One',
      //       backgroundColor: '#f87979',
      //       data: [40, 39, 45, 40, 39, 80, 40]
      //     }]
      // console.log(JSON.stringify(dataset2))

      // dataset1 = ({
      //       label: 'Data One',
      //       backgroundColor: '#f87979',
      //       data: [...data2]
      //     })
      // chartData.datasets={
      //   ...dataset1
      // }
    };
    return {
      i0,
      i1,
      i2,
      i3,
      i4,
      i5,
      i6,
      data,
      chartData,
      chartOptions,
      plusOne,
    };
  },
});
</script>
